xquery version "3.0";

declare namespace trigger = "http://exist-db.org/xquery/trigger";

import module namespace validation = "http://exist-db.org/xquery/validation";
import module namespace xmldb = "http://exist-db.org/xquery/xmldb";



declare function trigger:after-move-collection($uri as xs:anyURI, $new-uri as xs:anyURI) {
    
    (: TODO validate with DocBook Schema and then business rules with Schematron
    to ensure that Editorial changes are correct
    and take approriate action :)
    
    
    (: after sucessful validation move to assembly/process collection :)
    let $assembly-process-coll := "/db/publishing/articles/assembly/process"
    let $move := xmldb:move($new-uri, $assembly-process-coll)
    let $uuid := replace($new-uri, ".*/", "")
    return
        update insert
            <assembly-process timestamp="{current-dateTime()}">{$assembly-process-coll || "/" || $uuid}</assembly-process>
        into doc(xs:anyURI("/db/publishing/articles/status.xml"))/articles/article[@id eq $uuid]
};


(: main: do nothing - this is a trigger :)
()